package pnc;
import java.awt.*;
import cs101.util.semaphore.GraphicalSemaphore;

public abstract class Buffer {
  protected GraphicalSemaphore read;
  protected GraphicalSemaphore write;
  protected Panel bufferPanel;

  public Buffer() {
    // will be setup by subclasses
    this.read = null;   
    this.write = null;  

    this.bufferPanel = new Panel();    
    this.bufferPanel.add(new Label("Storage"));
    
  }

  public abstract void produce();
  public abstract void consume();
  
  public Panel getReadFlag() { return (Panel)read; } 
  public Panel getWriteFlag() { return (Panel)write; }
  public Panel getStoragePanel() { return bufferPanel; }

}







