package pnc;
import java.awt.*;
import cs101.awt.ColorField;
import cs101.util.semaphore.GBS;

public
class SingleBuffer extends Buffer {
  private ColorField buffer;

  public SingleBuffer() {
    // setup super class instance variables
    super();
    this.read = new GBS(true, "Read");
    this.write = new GBS(false, "Write");
    this.bufferPanel = new Panel();

    // setup my instance variables
    this.buffer = new ColorField(false, new Dimension(30,30),
				 Color.blue, Color.lightGray);

    // add display panel for buffer
    this.bufferPanel.add(this.buffer);
    
  }

  public void produce() {
    this.write.request();
    this.buffer.changeState(true);
    this.read.release();
  }

 public void consume() {
    this.read.request();
    this.buffer.changeState(false);
    this.write.release();
 }

}
