package pnc;
import java.awt.*;
import java.awt.event.*;

public
abstract class InterPNC extends PNC {
  private Button consume;
  private Button produce;  

  public void init() {  
    // call super class layout
    super.init();

    // create buttons
    this.consume = new Button("Consume");
    this.consume.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
	Consumer unmaker = 
	  new Consumer(InterPNC.this.store, 
		       InterPNC.this.toConsume); 
	unmaker.start();
      }
    });
    this.produce = new Button("Produce");
    this.produce.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
	Producer maker = 
	  new Producer(InterPNC.this.store, 
		       InterPNC.this.toProduce);
	maker.start();  
      }    
    });
      
    // layout buttons
    Panel panel = new Panel();
    panel.add(this.produce);
    panel.add(this.consume);
    this.add("South", panel);
  }
}






