package pnc;

import cs101.awt.DefaultFrame;
import cs101.util.Coerce;

public class Main {

  public static void main(String[] args) {
    String name;
    PNC pnc;

    if (args.length == 0) {
      name = "pnc.NonMulti";
    } else {
      name = args[0];
    }
    try {
      pnc = (PNC) (Class.forName(name)).newInstance();
      pnc.init();
      DefaultFrame df = new DefaultFrame(pnc);
      df.init();
      pnc.start();
    } catch (Exception e) {
      System.err.println("Could not create an instance.  Aborting.");
      System.exit(0);
    }
  }
}
